#define VERSION "Panda309"
#define AUTHORS "(c)1999 aempirei"

#define _BSD_SOURCE
#define __BSD_SOURCE
#define __FAVOR_BSD
#define _USE_BSD

#define SRC_P htons(1000 + (getpid() % 1000))
#define T_WIN htons(0x4000 + (rand() % 0x4000))

#define OSF "pandaprints.conf"

#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <unistd.h>
#include <errno.h>
#include <netdb.h>
#include <ctype.h>
#include <fcntl.h>
#include <time.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <netinet/in_systm.h>
#include <sys/utsname.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netinet/ip.h>
#include <netinet/tcp.h>
#include <pcap.h>
#include "protocol.h"

#define SA   struct sockaddr
#define SAin struct sockaddr_in

#define IPV4_ADDRLEN 16
#define PORT_CLOSED 1
#define MIN_PKT 200

#define NLEN sizeof(struct node)

#define min(a, b) (((a) < (b)) ? (a) : (b))
#define max(a, b) (((a) > (b)) ? (a) : (b))

struct node {
   union {
      struct in_addr ip;
      char *name;
   } _;
   u_short win;
   struct node *n;
};

extern char *device; /* our interface to listen on */

extern struct in_addr local_ip; /* target ip address */
extern struct in_addr target_ip; /* target ip address */

extern u_short dst_port; /* destination port */

extern int pcap_off; /* header offset for pcap_next captured packets */

extern pcap_t *pd_raw; /* packet capture descriptor */
extern int sd_icmp; /* raw socket descriptor */
extern int sd_tcp; /* raw socket descriptor */

/* ipv4.c */
extern const char *ipv4_ntop(int, const void *, char *, size_t);
extern const char *ipv4_showname(int, const void *, char *, size_t);
extern u_short tcp_cksum(char *, int, struct in_addr, struct in_addr);
extern u_short in_cksum(u_short *, int);
extern int ipv4_rslvhost(char *, SAin *);

extern u_long get_ippacket(struct ip *, char *, int);
extern void term_devices(void);
extern void sendtcp(void);
extern void init_devices(void);

